program MisKan;
{$APPTYPE CONSOLE}
uses
  SysUtils;

type
  TState = record
    M,K,L : Byte; // (3,3,1),(2,1,0),... druha strana je doplnkem do (3,3,1) snaha docilit (0,0,0)
    Res : String[30];
  end;
  TStates = array of TState;

var
  AktStavy,NoveStavy : TStates;
  Done,Switch : Boolean;
  FinRes : String;

function DoM1(St : TState) : TState;
begin
  if St.L=0 then begin
    Result.M:=St.M+1;
  end else begin
    Result.M:=St.M-1;
  end;
  Result.L:=St.L+1 mod 2;
end;

function DoStep(Step : Byte; St : TState) : TState;
begin
  case Step of
    1,2 : begin
            Result.M:=St.M-(Step)*(2*St.L-1);
            Result.K:=St.K;
            Result.L:=(St.L+1) mod 2;
          end;
    3,4 : begin
            Result.M:=St.M;
            Result.K:=St.K-(Step-2)*(2*St.L-1);
            Result.L:=(St.L+1) mod 2;
          end;
    5   : begin
            Result.M:=St.M-(Step-4)*(2*St.L-1);
            Result.K:=St.K-(Step-4)*(2*St.L-1);
            Result.L:=(St.L+1) mod 2;
          end;
  end;
  Result.Res:=St.Res+IntToStr(Step)+',';
end;

function Check(St : TState) : Boolean;
begin
  Result:=(St.M in [0..3]) and (St.K in [0..3]) and (St.L in [0..1]) and
          ((St.M=St.K) or (St.M in [0,3])) and (not((St.M=3) and (St.K=3) and (St.L=1)));
end;

procedure AddToListUnique(St : TState; var States : TStates);
var I : Integer;
    Exist : Boolean;
begin
  Exist:=False;
  for I:=Length(States)-1 downto 0 do begin
    if (States[I].M=St.M) and (States[I].K=St.K) and (States[I].L=St.L) then begin
      Exist:=True;
      Break;
    end;
  end;
  if not Exist then begin
    SetLength(States,Length(States)+1);
    States[Length(States)-1]:=St;
  end;
end;

procedure DoBreathSearch(var FromStates, ToStates : TStates);
var I,J : Integer;
    St,NewSt : TState;
begin
  for I:=Length(FromStates)-1 downto 0 do begin
    St:=FromStates[I];
    for J:=1 to 5 do begin
      NewSt:=DoStep(J,St);
      if Check(NewSt) then begin
        AddToListUnique(NewSt,ToStates);
      end;
    end;
  end;
  SetLength(FromStates,0);
end;

procedure WriteStateDown(St : TState);
begin
  // Write('M:',St.M,',K:',St.K,',L:',St.L,' | ');
  if (St.L=0) then Write(St.M,St.K,'  *',3-St.M,3-St.K,' | ')
              else Write(St.M,St.K,'*  ',3-St.M,3-St.K,' | ');
end;

function WriteDownAndCheck(var States : TStates) : Boolean;
var I : Integer;
    St : TState;
begin
  Result:=False;
  for I:=Length(States)-1 downto 0 do begin
    St:=States[I];
    WriteStateDown(St);
    if (St.M=0) and (St.K=0) and (St.L=0) then begin
      Result:=True;
      FinRes:=St.Res;
    end;
  end;
  WriteLn;
  ReadLn;
end;

procedure WriteDownResult(S : String);
var I : Integer;
    St : TState;
begin
  St.M:=3;
  St.K:=3;
  St.L:=1;
  St.Res:='';
  WriteStateDown(St);
  WriteLn;
  for I:=1 to (Length(S) div 2) do begin
    St:=DoStep(StrToIntDef(S[2*I-1],0),St);
    WriteStateDown(St);
    WriteLn;
  end;
end;

begin
  WriteLn('Misionari a Kanibalove :');
  FinRes:='';
  Switch:=True;
  SetLength(NoveStavy,0);
  SetLength(AktStavy,1);
  AktStavy[0].M:=3;
  AktStavy[0].K:=3;
  AktStavy[0].L:=1;
  Done:=WriteDownAndCheck(AktStavy);
  while (not Done) and ((Length(AktStavy)>0) or (Length(NoveStavy)>0)) do begin
    if Switch then begin
      DoBreathSearch(AktStavy,NoveStavy);
      Done:=WriteDownAndCheck(NoveStavy);
    end else begin
      DoBreathSearch(NoveStavy,AktStavy);
      Done:=WriteDownAndCheck(AktStavy);
    end;
    Switch:=not Switch;
  end;
  if Done then begin
    WriteLn('Reseni nalezeno. '+FinRes);
    WriteDownResult(FinRes);
  end else begin
    WriteLn('Reseni nenalezeno!');
  end;
  ReadLn;
end.
